
// CAN_TestDlg.cpp :  
//

#include "stdafx.h"
#include "CAN_Test.h"
#include "CAN_TestDlg.h"

#include "CAN_DLL/CAN_Access.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCAN_TestDlg ȭ 
CCAN_TestDlg::CCAN_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCAN_TestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCAN_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_RECV_MESSAGE, _listRecvMessage);
}

BEGIN_MESSAGE_MAP(CCAN_TestDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, &CCAN_TestDlg::OnBnClickedButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_CONFIG, &CCAN_TestDlg::OnBnClickedButtonConfig)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CCAN_TestDlg::OnBnClickedButtonSend)
END_MESSAGE_MAP()


CAN_HANDLE hBus = -1;
bool openSuccess = false;

// CCAN_TestDlg ޽ ó

BOOL CCAN_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.
	SetDlgItemText (IDC_EDIT_SERIAL_PORT, "\\\\.\\COM3");
	SetDlgItemInt (IDC_EDIT_BAUDRATE, 921600);

	SetDlgItemInt (IDC_EDIT_BITRATE, 1000);
	SetDlgItemInt (IDC_EDIT_FILTER_ID, 0);
	SetDlgItemInt (IDC_EDIT_FILTER_MASK, 0);

	SetDlgItemText (IDC_EDIT_ID, "1");
	SetDlgItemText (IDC_EDIT_MESSAGE, "00 11 22 33 AA BB CC DD");

	SetTimer (1000, 100, NULL);

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CCAN_TestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CCAN_TestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CCAN_TestDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	openSuccess = false;

	if (0 <= hBus) {
		CAN_SetTransferMode (hBus, 0);	// Packet  

		CAN_Close (hBus);
		hBus = -1;
	}
}

void CCAN_TestDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == 1000) {
		if (openSuccess) {
			long id;
			int len;
			char data[8];
			int ext;
			int rtr;
			if (CAN_Recv (hBus, &id, &len, data, &ext, &rtr)) {
				char buff[64];
				int n = sprintf (buff, "%X : ", id);
				for (int i=0; i<len; i++) {
					n += sprintf (buff+n, "%02X ", (int)(unsigned char)data[i]);
				}
				n += sprintf (buff+n, "(%d) ", len);
				if (ext) n += sprintf (buff+n, "Ext ");
				if (rtr) n += sprintf (buff+n, "Rtr ");

				_listRecvMessage.AddString(buff); 
				_listRecvMessage.SetCurSel(_listRecvMessage.GetCount()-1); 
				_listRecvMessage.SetCurSel(-1); 
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CCAN_TestDlg::OnBnClickedButtonConnect()
{
	openSuccess = false;

	if (0 <= hBus) {
		CAN_Close (hBus);
		hBus = -1;
	}

	char serial_port[256];
	GetDlgItemText (IDC_EDIT_SERIAL_PORT, serial_port, sizeof(serial_port));
	long baudrate  = GetDlgItemInt (IDC_EDIT_BAUDRATE);

	if (strstr (serial_port, "COM")) {
		hBus = CAN_OpenVcp (serial_port, baudrate);
		if (0 <= hBus) {
			CAN_SetTransferMode (hBus, 1);	// Binary packet   
			openSuccess = true;
			AfxMessageBox ("CAN2USB(VCP) Ʈ µ Ͽϴ.");
			return;
		}
		else AfxMessageBox ("CAN2USB(VCP) Ʈ   ϴ.");
	}
	else {
		hBus = CAN_OpenFifo (serial_port);
		if (0 <= hBus) {
			CAN_SetTransferMode (hBus, 1);	// Binary packet   
			openSuccess = true;
			AfxMessageBox ("CAN2USB Ʈ µ Ͽϴ.");
			return;
		}
		else AfxMessageBox ("CAN2USB Ʈ   ϴ.");
	}
}

void CCAN_TestDlg::OnBnClickedButtonConfig()
{
	if (openSuccess) {
		long bitrate = GetDlgItemInt (IDC_EDIT_BITRATE);
		unsigned long filter_id = GetDlgItemHexa (IDC_EDIT_FILTER_ID);
		unsigned long filter_mask = GetDlgItemHexa (IDC_EDIT_FILTER_MASK);

		if (CAN_SetConfig (hBus, bitrate, filter_id, filter_mask));
		else AfxMessageBox ("CAN2USB ġ   ϴ.");
	}
}

void CCAN_TestDlg::OnBnClickedButtonSend()
{
	if (openSuccess) {
		long id = GetDlgItemHexa (IDC_EDIT_ID);
		char data[8];
		int len = GetDlgItemHexa8 (IDC_EDIT_MESSAGE, data);

		if (CAN_Send (hBus, id, len, data, 0, 0));
		else AfxMessageBox ("CAN2USB ġ ޽   ϴ.");
	}
}
